package ink.wgink.interfaces.position;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.dtos.ZTreeDTO;
import ink.wgink.pojo.dtos.position.PositionDTO;
import ink.wgink.pojo.pos.PositionPO;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: IPositionService
 * @Description: 职位
 * @Author: WangGeng
 * @Date: 2021/1/24 12:54
 * @Version: 1.0
 **/
public interface IPositionBaseService {

    /**
     * 全部职位JSON列表
     *
     * @param groupParentId
     * @return
     */
    List<PositionDTO> listAllByParentId(String groupParentId);

    /**
     * 职位列表，递归获取全部内容
     *
     * @param params
     * @return
     */
    List<PositionDTO> listAll(Map<String, Object> params);

    /**
     * 职位详情
     *
     * @param params
     * @return
     */
    PositionDTO get(Map<String, Object> params);

    /**
     * 职位详情
     *
     * @param positionId
     * @return
     */
    PositionDTO get(String positionId);

    /**
     * 职位zTree列表
     *
     * @param params
     * @return
     */
    List<ZTreeDTO> listZTree(Map<String, Object> params);

    /**
     * 职位EasyUI列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<PositionDTO>> listPage(ListPage page);

    /**
     * 职位列表
     *
     * @param params
     * @return
     */
    List<PositionDTO> list(Map<String, Object> params);

    /**
     * 职位列表
     *
     * @param groupIds 用户ID列表
     * @return
     */
    List<PositionDTO> list(List<String> groupIds);

    /**
     * 职位列表
     *
     * @param params
     * @return
     */
    List<PositionPO> listPO(Map<String, Object> params);

    /**
     * 职位列表
     *
     * @param positionIds
     * @return
     */
    List<PositionPO> listPO(List<String> positionIds);

    /**
     * 统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);
}
